#pragma once

#if ODE_SINGLE_PRECISION
	typedef float OdeReal;
	typedef Eigen::VectorXf OdeVectorReal;
	typedef Eigen::MatrixXf OdeMatrixReal;
#else
	typedef double OdeReal;
	typedef Eigen::VectorXd OdeVectorReal;
	typedef Eigen::MatrixXd OdeMatrixReal;
#endif

class LinearSolver
{
public:
	virtual ~LinearSolver() {}
	virtual bool Init(size_t n) = 0;
	virtual int Setup(void* cvode_mem, int convfail, OdeReal* ypred, int* jcurPtr) = 0;
	virtual int Solve(void* cvode_mem, OdeReal* b) = 0;

protected:
};
