#pragma once

namespace bcm {

class VariableSet;

class PosteriorSampleHandlerFileDumper
{
public:
	PosteriorSampleHandlerFileDumper(size_t buffer_size = 100);
	~PosteriorSampleHandlerFileDumper();

	void SetFile(const std::string& filename);
	void SetVariableSet(const VariableSet* varset);
	bool Initialize();
	void Handle(const Real* values, Real lposterior, Real llh, Real lprior, Real weight, void*);

	boost::function<void (const Real* values, Real lposterior, Real llh, Real lprior, Real weight, void* user)> GetFunctionPointer();

private:
	void Flush();

	std::string filename;
	bool binary;
	const VariableSet* varset;
	bool Initialized;

	struct Sample
	{
		VectorReal values;
		Real lprior;
		Real llh;
		Real lposterior;
		Real weight;
	};

	std::vector<Sample> output_buffer;
	size_t output_buffer_ix;
};

}
