#pragma once

namespace bcm {

class ProgressIndicator
{
public:
	ProgressIndicator();
	virtual ~ProgressIndicator();

	void NotifyStart();
	void NotifyStop();
	void UpdateInfo(const char* name, const std::string& value);

	/// Call UpdateInfo before ReportProgress
	void ReportProgress(Real progress);

protected:
	virtual void OnUpdate() {}
	virtual void OnStop() {}

	Real current_progress;
	std::map<std::string, std::string> current_info;

	Timer timer;
	Real current_run_time;
	Real expected_run_time;
	Real expected_remaining_time;
	Real expected_remaining_time_ema;
	std::string eta;
};

}
