#include "Utils.h"
#include "Sample.h"

namespace bcm {

Sample::Sample()
	: lprior(-std::numeric_limits<Real>::quiet_NaN())
	, llh(-std::numeric_limits<Real>::quiet_NaN())
	, lposterior(-std::numeric_limits<Real>::quiet_NaN())
	, weight(-std::numeric_limits<Real>::quiet_NaN())
	, sampled_from_cluster(std::numeric_limits<size_t>::max())
{
}

Sample::Sample(size_t nvar, size_t noutput)
	: variable_values(static_cast<int>(nvar))
	, output_values(static_cast<int>(noutput))
	, lprior(-std::numeric_limits<Real>::quiet_NaN())
	, llh(-std::numeric_limits<Real>::quiet_NaN())
	, lposterior(-std::numeric_limits<Real>::quiet_NaN())
	, weight(-std::numeric_limits<Real>::quiet_NaN())
	, unit_values(static_cast<int>(nvar))
	, sampled_from_cluster(std::numeric_limits<size_t>::max())
{
}

Sample::~Sample()
{
}

}
