#pragma once

#include "LinearSolverSBML.h"
#include <Eigen/SparseLU>

class SBMLModel;

class LinearSolverEigenSparseLU : public LinearSolverSBML
{
public:
	LinearSolverEigenSparseLU(SBMLModel* model);
	~LinearSolverEigenSparseLU();

	virtual bool Init(size_t N);
	virtual int Setup(void* cvode_mem, int convfail, OdeReal* ypred, int* jcurPtr);
	virtual int Solve(void* cvode_mem, OdeReal* b);

private:
	void EvaluateJacobian(const OdeReal* species, const OdeReal* parameters);

	int N;
	Eigen::SparseMatrix<OdeReal> M;
	Eigen::SparseMatrix<OdeReal> SavedJ;
	Eigen::SparseLU< Eigen::SparseMatrix<OdeReal> > solver;

	long int nstlj;
};
