#pragma once

#define USE_MKL 0
#if USE_MKL

#include "LinearSolverSBML.h"
#include <Eigen/LU>

class SBMLModel;

class LinearSolverMKL : public LinearSolverSBML
{
public:
	LinearSolverMKL(SBMLModel* model);
	~LinearSolverMKL();

	virtual bool Init(size_t N);
	virtual int Setup(void* cvode_mem, int convfail, OdeReal* ypred, int* jcurPtr);
	virtual int Solve(void* cvode_mem, OdeReal* b);

private:
	void EvaluateJacobian(const OdeReal* species, const OdeReal* parameters);

	size_t N;
	OdeMatrixReal M;
	OdeMatrixReal SavedJ;
	std::vector<int> pivots;

	Eigen::PartialPivLU< OdeMatrixReal > solver;

	long int nstlj;
};

#endif
