#pragma once

#include "VariableSet.h"

class ExperimentalCondition;
class SBMLModel;

class SBMLModelParameters
{
public:
	SBMLModelParameters(SBMLModel* model);
	~SBMLModelParameters();

	bool SetVariableSet(const bcm::VariableSet* variables);
	void ResetForcedVariables();
	bool SetForcedVariable(const std::string& variable_name, Real value);

	void UpdateVariableValues(Real* variables) const;
	void UpdateInitialValues(Real* initial_values) const;

private:
	const SBMLModel* Model;
	const bcm::VariableSet* Variables;

	// Forcing variable to specific values
	std::map<size_t, Real> ForcedVariableValues;
	std::map<size_t, Real> ForcedInitialConditions;
};
