#pragma once

#include "SBMLPDExperiment.h"

class SignalingNetwork;

class SBMLPDExperimentDrugRange : public SBMLPDExperiment
{
public:
	SBMLPDExperimentDrugRange(size_t numthreads);
	virtual ~SBMLPDExperimentDrugRange();
	
	virtual bool SetupAdditionalOutput(bcm::NetCDFDataFile* file, size_t sample_count);
	virtual void HandleAdditionalOutput(bcm::NetCDFDataFile* file, size_t sample_ix, const Real* values, size_t& value_ix);
	virtual bool EvaluateLogProbability(size_t threadix, const Real* values, Real& logp, std::vector<SBMLPDExperiment*> other_experiments);
	virtual bool GetOutput(size_t threadix, Real* output_values, size_t& numvalues);

private:
	virtual bool LoadTypeSpecificNodes(const boost::property_tree::ptree& xml_node, const bcm::NetCDFDataFile* datafile);
	virtual bool InitializeParallelData();
	virtual bool ParseDataNode(const boost::property_tree::ptree& xml_node, std::vector<SBMLPDExperiment*> other_experiments, const bcm::NetCDFDataFile* datafile);

	struct DataPart : public DataPartBase
	{
		std::vector<MatrixReal> data;
	};
	
	struct ParallelData : public ParallelDataBase {
		std::vector< std::vector<VectorReal> > activities;
		std::vector< std::vector<VectorReal> > modeled_data_values;
	};

	std::vector<DataPart> data;

	std::string drug_species_name;
	size_t drug_model_ix;
	VectorReal drug_concentrations;

	std::vector<ParallelData> parallel_data;
};
