#pragma once

#include "SBMLPDExperiment.h"

class SignalingNetwork;

class SBMLPDExperimentSingleCondition : public SBMLPDExperiment
{
public:
	SBMLPDExperimentSingleCondition(size_t numthreads);
	virtual ~SBMLPDExperimentSingleCondition();
	
	virtual bool SetupAdditionalOutput(bcm::NetCDFDataFile* file, size_t sample_count);
	virtual void HandleAdditionalOutput(bcm::NetCDFDataFile* file, size_t sample_ix, const Real* values, size_t& value_ix);
	virtual bool EvaluateLogProbability(size_t threadix, const Real* values, Real& logp, std::vector<SBMLPDExperiment*> other_experiments);
	virtual bool GetOutput(size_t threadix, Real* output_values, size_t& numvalues);

protected:
	virtual bool InitializeParallelData();
	virtual bool ParseDataNode(const boost::property_tree::ptree& xml_node, std::vector<SBMLPDExperiment*> other_experiments, const bcm::NetCDFDataFile* datafile);
	
	struct DataPart : public DataPartBase
	{
		std::vector<VectorReal> data;
	};
	
	struct ParallelData : public ParallelDataBase {
		std::vector<VectorReal> activities;
		std::vector<VectorReal> modeled_data_values;
	};

	std::vector<DataPart> data;

	std::vector<ParallelData> parallel_data;

	friend class SBMLPDExperimentDrugRange;
};
