#pragma once

#include <boost/serialization/serialization.hpp>
#include <boost/serialization/array.hpp>
#include <boost/serialization/vector.hpp>

#pragma warning (push)
#pragma warning( disable : 4244 )
#include <boost/archive/binary_oarchive.hpp>
#include <boost/archive/binary_iarchive.hpp>
#pragma warning (pop) 

namespace boost {
namespace serialization {

template<class Archive, typename _Scalar, int _Rows, int _Cols, int _Options, int _MaxRows, int _MaxCols>
void serialize(Archive & ar, Eigen::Matrix<_Scalar, _Rows, _Cols, _Options, _MaxRows, _MaxCols> & x, const unsigned int version)
{
    size_t rows = x.rows(), cols = x.cols();
    ar & rows;
    ar & cols;
    if (rows * cols != x.size()) {
		x.resize(rows, cols);
	}

	for (int i = 0; i < x.size(); i++) {
		ar & x.data()[i];
	}
}

}
}
