#pragma once

namespace bcm {

void sort(VectorReal& x);
void sort(VectorReal& x, VectorReal& aux);
void sort(VectorReal& x, VectorReal& aux1, VectorReal& aux2);

template<typename T>
bool ParseMatrixFromString(const std::string& str, Eigen::Matrix<T, -1, -1>& matrix, size_t N)
{
	std::vector<std::string> vec;
	bcm::tokenize(str, vec, ";");
	if (vec.size() != N * N) {
		LOGERROR("Dimension of matrix does not match the required size");
		return false;
	}
	matrix.resize(N, N);
	for (size_t i = 0; i < N; i++) {
		for (size_t j = 0; j < N; j++) {
			T value = boost::lexical_cast<T>(vec[j*N+i]);
			matrix(i, j) = value;
		}
	}
	return true;
}

bool ParseVectorFromString(const std::string& str, VectorReal& v);

}
