#include "Utils.h"
#include <boost/test/unit_test.hpp>

#include "MathFunctions.h"

BOOST_AUTO_TEST_CASE(MathFunctions_rsqrt)
{
	double a = 18.2;
	double res = bcm::rsqrt(a);
	BOOST_CHECK_CLOSE(res, 1.0 / sqrt(a), 0.000001);
}

BOOST_AUTO_TEST_CASE(MathFunctions_logsum)
{
	double a = 2.3;
	double b = 4.1;
	double res = bcm::logsum(a, b);
	BOOST_CHECK_CLOSE(res, log(exp(a) + exp(b)), 0.000001);
}

BOOST_AUTO_TEST_CASE(MathFunctions_logaminusb)
{
	double a = 4.1;
	double b = 2.3;
	double res = bcm::logaminusb(a, b);
	BOOST_CHECK_CLOSE(res, log(exp(a) - exp(b)), 0.000001);

	a = 2.3;
	b = 4.1;
	res = bcm::logaminusb(a, b);
	BOOST_CHECK(res != res);
}
